#include "stdafx.h"

#include <d3dtypes.h>
#include <DDraw.h>
#include <ISTBTDDExt.h>

#include "tulsa sample app.h"
#include "mainfrm.h"
#include "CardDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define VIDEO_OVERLAY_WIDTH		720
#define VIDEO_OVERLAY_HEIGHT	480

#define VIDEO_WIDTH		720
#define VIDEO_HEIGHT	480

#define VIDEO_LEFT_OFFSET	50


DWORD RGBPortID[MAX_VIDEO_PORTS];		// List of video port IDs of RGB processor 
int NumRGBPortIDs;

DWORD YUVPortID[MAX_VIDEO_PORTS];		// List of video port IDs of YUV processor
int NumYUVPortIDs;

HRESULT WINAPI EnumVideoCallbackYUV(LPDDVIDEOPORTCAPS lpDDVideoPortCaps, LPVOID lpContext)
{
	YUVPortID[NumYUVPortIDs] = lpDDVideoPortCaps->dwVideoPortID;
	NumYUVPortIDs++;
	return(DDENUMRET_OK);
}


void CCardDlg::StartVideoTestYUV(int Port)
{
	HRESULT result;

	if (Port > MAX_VIDEO_PORTS) {
		return;
	}

	if (bVideoTestStartedYUV[Port]) {
		return;
	}


	LPDDVIDEOPORTCONTAINER lpDDVideoPortContainer;

    result = lpDirectDrawYUV->QueryInterface(IID_IDDVideoPortContainer, (void **)&lpDDVideoPortContainer);
	if(!FAILED(result)) {
		if (NumYUVPortIDs == 0) {
			lpDDVideoPortContainer->EnumVideoPorts(0, NULL, NULL, EnumVideoCallbackYUV);
		}

		DDVIDEOPORTDESC DDVideoPortDesc;
	    INIT_DIRECTDRAW_STRUCT(DDVideoPortDesc);
		DDVideoPortDesc.dwVideoPortID = YUVPortID[Port];
		DDVideoPortDesc.dwFieldWidth = VIDEO_WIDTH;
		DDVideoPortDesc.dwFieldHeight = VIDEO_HEIGHT/2;

		if (lpDDVideoPortContainer->CreateVideoPort(0, &DDVideoPortDesc, &lpDDVideoPortYUV[Port], NULL) == DD_OK) {

			DDVIDEOPORTINFO DDVideoPortInfo;
			INIT_DIRECTDRAW_STRUCT(DDVideoPortInfo);

			if (Port == PRIMARY_VIDEO_PORT) {
				DDVideoPortInfo.dwVPFlags = DDVP_CROP | DDVP_PRESCALE;
				DDVideoPortInfo.rCrop.left = pYUVPriVideoOvly->m_SrcCropPosition.x;
				DDVideoPortInfo.rCrop.top = pYUVPriVideoOvly->m_SrcCropPosition.y;
				DDVideoPortInfo.rCrop.right = DDVideoPortInfo.rCrop.left + pYUVPriVideoOvly->m_SrcCropSize.cx - 1;
				DDVideoPortInfo.rCrop.bottom = DDVideoPortInfo.rCrop.top + pYUVPriVideoOvly->m_SrcCropSize.cy - 1;

				DDVideoPortInfo.dwOriginX = pYUVPriVideoOvly->m_Position.x;
				DDVideoPortInfo.dwOriginY = pYUVPriVideoOvly->m_Position.y;

				DDVideoPortInfo.dwPrescaleWidth = pYUVPriVideoOvly->m_Size.cx;
				DDVideoPortInfo.dwPrescaleHeight = pYUVPriVideoOvly->m_Size.cy;
			} else {
				DDVideoPortInfo.dwVPFlags = DDVP_CROP | DDVP_PRESCALE;
				DDVideoPortInfo.rCrop.left = pYUVSecVideoOvly->m_SrcCropPosition.x;
				DDVideoPortInfo.rCrop.top = pYUVSecVideoOvly->m_SrcCropPosition.y;
				DDVideoPortInfo.rCrop.right = DDVideoPortInfo.rCrop.left + pYUVSecVideoOvly->m_SrcCropSize.cx - 1;
				DDVideoPortInfo.rCrop.bottom = DDVideoPortInfo.rCrop.top + pYUVSecVideoOvly->m_SrcCropSize.cy - 1;

				DDVideoPortInfo.dwOriginX = pYUVSecVideoOvly->m_Position.x;
				DDVideoPortInfo.dwOriginY = pYUVSecVideoOvly->m_Position.y;

				DDVideoPortInfo.dwPrescaleWidth = pYUVSecVideoOvly->m_Size.cx;
				DDVideoPortInfo.dwPrescaleHeight = pYUVSecVideoOvly->m_Size.cy;
			}
										// Enable video
			lpDDVideoPortYUV[Port]->StartVideo(&DDVideoPortInfo);

			bVideoTestStartedYUV[Port] = TRUE;
		}

		lpDDVideoPortContainer->Release();
	}
}


void CCardDlg::StopVideoTestYUV(int Port)
{
	if (Port > MAX_VIDEO_PORTS) {
		return;
	}

	if (!bVideoTestStartedYUV[Port]) {
		return;
	}

	if (lpDDVideoPortYUV[Port]) {
		lpDDVideoPortYUV[Port]->Release();
		lpDDVideoPortYUV[Port] = NULL;
	}

	bVideoTestStartedYUV[Port] = FALSE;
}

void CCardDlg::StopVideoTestAllYUV()
{
	for (int i = 0; i < MAX_VIDEO_PORTS; i++) {
		StopVideoTestYUV(i);
	}
}


void CCardDlg::UpdateVideoTestYUV(int Port)
{
	if (!bVideoTestStartedYUV[Port]) {
		return;
	}
	if (lpDDVideoPortYUV[Port] == NULL) {
		return;
	}
			
	DDVIDEOPORTINFO DDVideoPortInfo;
	INIT_DIRECTDRAW_STRUCT(DDVideoPortInfo);

	if (Port == PRIMARY_VIDEO_PORT) {
		DDVideoPortInfo.dwVPFlags = DDVP_CROP | DDVP_PRESCALE;
		DDVideoPortInfo.rCrop.left = pYUVPriVideoOvly->m_SrcCropPosition.x;
		DDVideoPortInfo.rCrop.top = pYUVPriVideoOvly->m_SrcCropPosition.y;
		DDVideoPortInfo.rCrop.right = DDVideoPortInfo.rCrop.left + pYUVPriVideoOvly->m_SrcCropSize.cx - 1;
		DDVideoPortInfo.rCrop.bottom = DDVideoPortInfo.rCrop.top + pYUVPriVideoOvly->m_SrcCropSize.cy - 1;

		DDVideoPortInfo.dwOriginX = pYUVPriVideoOvly->m_Position.x;
		DDVideoPortInfo.dwOriginY = pYUVPriVideoOvly->m_Position.y;

		DDVideoPortInfo.dwPrescaleWidth = pYUVPriVideoOvly->m_Size.cx;
		DDVideoPortInfo.dwPrescaleHeight = pYUVPriVideoOvly->m_Size.cy;
	} else {
		DDVideoPortInfo.dwVPFlags = DDVP_CROP | DDVP_PRESCALE;
		DDVideoPortInfo.rCrop.left = pYUVSecVideoOvly->m_SrcCropPosition.x;
		DDVideoPortInfo.rCrop.top = pYUVSecVideoOvly->m_SrcCropPosition.y;
		DDVideoPortInfo.rCrop.right = DDVideoPortInfo.rCrop.left + pYUVSecVideoOvly->m_SrcCropSize.cx - 1;
		DDVideoPortInfo.rCrop.bottom = DDVideoPortInfo.rCrop.top + pYUVSecVideoOvly->m_SrcCropSize.cy - 1;

		DDVideoPortInfo.dwOriginX = pYUVSecVideoOvly->m_Position.x;
		DDVideoPortInfo.dwOriginY = pYUVSecVideoOvly->m_Position.y;
		// Scaling not possible with secondary port
	}
										// Update video port
	lpDDVideoPortYUV[Port]->UpdateVideo(&DDVideoPortInfo);
}



//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
/// Video Port Methods for RGB Processor
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

HRESULT WINAPI EnumVideoCallbackRGB(LPDDVIDEOPORTCAPS lpDDVideoPortCaps, LPVOID lpContext)
{
	RGBPortID[NumRGBPortIDs] = lpDDVideoPortCaps->dwVideoPortID;
	NumRGBPortIDs++;
	return(DDENUMRET_OK);
}


void CCardDlg::StartVideoTestRGB(void)
{
	HRESULT result;
	DDSURFACEDESC   ddsd;

	if (bVideoTestStartedRGB) {
		return;
	}

    INIT_DIRECTDRAW_STRUCT(ddsd);
	ddsd.dwHeight = VIDEO_OVERLAY_HEIGHT;
	ddsd.dwWidth = VIDEO_OVERLAY_WIDTH;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);

	ddsd.ddpfPixelFormat.dwFlags = DDPF_YUV;
	ddsd.ddpfPixelFormat.dwYUVBitCount = 16;
    ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY | DDSCAPS_VIDEOPORT;

	result = lpDD2RGB->CreateSurface(&ddsd, &lpDDSOverlayVideo, NULL);
	if (result != DD_OK) {
		lpDDSOverlayVideo = NULL;
		return;
	}

	LPDDVIDEOPORTCONTAINER lpDDVideoPortContainer;

    result = lpDirectDrawRGB->QueryInterface(IID_IDDVideoPortContainer, (void **)&lpDDVideoPortContainer);
	if(!FAILED(result)) {
		if (NumRGBPortIDs == 0) {
			lpDDVideoPortContainer->EnumVideoPorts(0, NULL, NULL, EnumVideoCallbackRGB);
		}

		DDVIDEOPORTDESC DDVideoPortDesc;
	    INIT_DIRECTDRAW_STRUCT(DDVideoPortDesc);
		DDVideoPortDesc.dwVideoPortID = RGBPortID[0];
		DDVideoPortDesc.dwFieldWidth = VIDEO_WIDTH;
		DDVideoPortDesc.dwFieldHeight = VIDEO_HEIGHT/2;

		if (lpDDVideoPortContainer->CreateVideoPort(0, &DDVideoPortDesc, &lpDDVideoPortRGB, NULL) == DD_OK) {

			lpDDVideoPortRGB->SetTargetSurface(lpDDSOverlayVideo, DDVPTARGET_VIDEO);

			DDVIDEOPORTINFO DDVideoPortInfo;
			INIT_DIRECTDRAW_STRUCT(DDVideoPortInfo);
			lpDDVideoPortRGB->StartVideo(&DDVideoPortInfo);
		}

		lpDDVideoPortContainer->Release();
	}

	RECT SrcRect;
	RECT DestRect;

	SrcRect.left = pRGBVideoOvly->m_SrcCropPosition.x;
	SrcRect.top = pRGBVideoOvly->m_SrcCropPosition.y;
	SrcRect.right = SrcRect.left + pRGBVideoOvly->m_SrcCropSize.cx - 1;
	SrcRect.bottom = SrcRect.top + pRGBVideoOvly->m_SrcCropSize.cy - 1;

	DestRect.left = pRGBVideoOvly->m_Position.x;
	DestRect.top = pRGBVideoOvly->m_Position.y;
	DestRect.right = DestRect.left + pRGBVideoOvly->m_Size.cx - 1;
	DestRect.bottom = DestRect.top + pRGBVideoOvly->m_Size.cy - 1;
										// Show video overlay
	lpDDSOverlayVideo->UpdateOverlay(&SrcRect, lpDDSPrimaryRGB, &DestRect, 
		DDOVER_SHOW, NULL);

	LPTULSASURFACEEXT lpTulsaSurfaceExt;

	result = CoCreateInstance(CLSID_STBTDDExtension, NULL, 
		CLSCTX_INPROC, IID_ISTBTDDSurfaceExt, (LPVOID *)&lpTulsaSurfaceExt);
	if (result != DD_OK) {
		return;
	}
											// Assign surface being extended
	lpTulsaSurfaceExt->AssignSurface(lpDDSOverlayVideo);

	SURFACEDESCEXT SurfaceDescExt;
	INIT_DIRECTDRAW_STRUCT(SurfaceDescExt);
	SurfaceDescExt.dwFlags = 0;
	SurfaceDescExt.bPreserveDestAlpha = !pRGBVideoOvly->m_bWriteAlpha;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

	lpTulsaSurfaceExt->Release();

	bVideoTestStartedRGB = TRUE;

}


void CCardDlg::StopVideoTestRGB()
{
	if (!bVideoTestStartedRGB) {
		return;
	}

	if (lpDDVideoPortRGB) {
		lpDDVideoPortRGB->StopVideo();
		lpDDVideoPortRGB->Release();
		lpDDVideoPortRGB = NULL;
	}

	if (lpDDSOverlayVideo) {
		lpDDSOverlayVideo->Release();
		lpDDSOverlayVideo = NULL;
	}
	bVideoTestStartedRGB = FALSE;
}



void CCardDlg::UpdateVideoTestRGB()
{
	RECT SrcRect;
	RECT DestRect;

	if (lpDDSOverlayVideo == NULL) {
		return;
	}

	SrcRect.left = pRGBVideoOvly->m_SrcCropPosition.x;
	SrcRect.top = pRGBVideoOvly->m_SrcCropPosition.y;
	SrcRect.right = SrcRect.left + pRGBVideoOvly->m_SrcCropSize.cx - 1;
	SrcRect.bottom = SrcRect.top + pRGBVideoOvly->m_SrcCropSize.cy - 1;

	DestRect.left = pRGBVideoOvly->m_Position.x;
	DestRect.top = pRGBVideoOvly->m_Position.y;
	DestRect.right = DestRect.left + pRGBVideoOvly->m_Size.cx - 1;
	DestRect.bottom = DestRect.top + pRGBVideoOvly->m_Size.cy - 1;
										// Show video overlay
	if (lpDDSOverlayVideo) {
		lpDDSOverlayVideo->UpdateOverlay(&SrcRect, lpDDSPrimaryRGB, &DestRect, 
			DDOVER_SHOW, NULL);
	}

	if (RGBVideoZOrderFlags) {
		lpDDSOverlayVideo->UpdateOverlayZOrder(RGBVideoZOrderFlags & 0xfffffff, NULL);
		RGBVideoZOrderFlags = 0;
	}

	LPTULSASURFACEEXT lpTulsaSurfaceExt;

	HRESULT result = CoCreateInstance(CLSID_STBTDDExtension, NULL, 
		CLSCTX_INPROC, IID_ISTBTDDSurfaceExt, (LPVOID *)&lpTulsaSurfaceExt);
	if (result != DD_OK) {
		return;
	}
											// Assign surface being extended
	lpTulsaSurfaceExt->AssignSurface(lpDDSOverlayVideo);

	SURFACEDESCEXT SurfaceDescExt;
	INIT_DIRECTDRAW_STRUCT(SurfaceDescExt);
	SurfaceDescExt.dwFlags = 0;
	SurfaceDescExt.bPreserveDestAlpha = !pRGBVideoOvly->m_bWriteAlpha;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

	lpTulsaSurfaceExt->Release();
}
